<template>
  <q-page>
    <div class="q-pa-md">
      <q-dialog v-model="verProduct" persistent>
        <q-card>
          <q-card-section class="row items-center">
            <!-- lista de productos en el pedido -->
            <q-list style="width: 100%" class="rounded-borders">
              <div
                class="flex column"
                v-for="pedido in paraPedir"
                :key="pedido.id"
              >
                <q-item>
                  <q-item-section avatar top> </q-item-section>
                  <q-item-section
                    top
                    style="min-width: 400px; max-width: 600px"
                  >
                    <q-item-label lines="1">
                      <span class="text-weight-medium">
                        Cod. {{ pedido.id }} - {{ pedido.description }}
                      </span>
                      <span class="text-grey-8">
                        - Precio Unidad: ${{ pedido.price }}
                      </span>
                    </q-item-label>
                    <q-item-label caption lines="1">
                      Pedido Cant.: {{ pedido.cantPedida }} total precio: $
                      {{ pedido.cantPedida * pedido.price }}
                    </q-item-label>
                    <!-- <q-item-label caption lines="1"> </q-item-label>
                              <q-item-label lines="1">
                                <span class="cursor-pointer">Open in GitHub</span>
                              </q-item-label> -->
                    <q-input
                      dense
                      v-model="pedido.observaciones"
                      filled
                      label="Observaciones"
                      type="text"
                    />
                  </q-item-section>

                  <q-item-section top side>
                    <div class="text-grey-8 q-gutter-xs">
                      <!-- desde aca -->
                      <div class="center" style="width: 100px">
                        <q-input
                          readonly
                          type="text"
                          dense
                          rounded
                          outlined
                          bottom-slots
                          v-model="pedido.cantPedida"
                          :rules="[
                            (val) =>
                              val >= 0 || 'Debe ingresar un valor mayor a 1',
                          ]"
                          input-class="text-center"
                        >
                          <template v-slot:prepend>
                            <q-icon
                              name="remove"
                              @click="
                                (pedido.cantPedida = pedido.cantPedida - 1),
                                  (this.precioTotal =
                                    pedido.cantPedida < 0
                                      ? this.precioTotal
                                      : this.precioTotal - pedido.price),
                                  (pedido.cantPedida =
                                    pedido.cantPedida < 0
                                      ? 0
                                      : pedido.cantPedida)
                              "
                            />
                          </template>
                          <template v-slot:append>
                            <q-icon
                              name="add"
                              @click="
                                (pedido.cantPedida = pedido.cantPedida + 1),
                                  (this.precioTotal =
                                    this.precioTotal + pedido.price)
                              "
                              class="cursor-pointer"
                            />
                          </template>
                        </q-input>
                      </div>
                      <!-- hasta aca -->
                    </div>
                  </q-item-section>
                </q-item>
                <!-- </div> -->

                <q-separator />
              </div>
            </q-list>

            <!-- fin lista -->
          </q-card-section>
          <q-card-actions align="right">
            <q-btn flat label="Cerrar" color="primary" v-close-popup />
          </q-card-actions>
        </q-card>
      </q-dialog>
      <div style="width: 100%">
        <q-tabs v-model="tab" align="justify" narrow-indicator class="q-mb-lg">
          <q-tab
            class="text-blue"
            name="pedidos"
            icon="store"
            label="Pedidos"
          />
          <q-tab
            class="text-green"
            name="carrito"
            icon="shopping_cart"
            label="Carrito"
            v-if="totalCarrito > 0"
            @click="getUsers()"
          >
            <q-badge color="green" floating>{{ totalCarrito }} </q-badge>
          </q-tab>
          <q-tab class="text-teal" name="mispedidos" label="Mis Pedidos" />
        </q-tabs>

        <div class="q-gutter-y-sm">
          <!-- Productos -->
          <q-tab-panels
            v-model="tab"
            animated
            transition-prev="scale"
            transition-next="scale"
            class="bg-blue-2 text-black text-center"
          >
            <q-tab-panel name="pedidos">
              <div class="text-h6">Pedidos</div>
              <div class="q-gutter-y-md flex column" style="width: 100%">
                <q-input rounded bottom-slots v-model="text" @keyup="filtro">
                  <template v-slot:append>
                    <q-avatar>
                      <img src="~assets/boy-avatar.png" />
                    </q-avatar>
                  </template>
                </q-input>
              </div>
              <div class="row">
                <div v-for="product in allProducts" :key="product.id">
                  <ViewProduct v-bind="product" @addCard="getToCart" />
                </div>
              </div>
            </q-tab-panel>
          </q-tab-panels>

          <!-- Carrito -->
          <q-tab-panels
            v-model="tab"
            animated
            transition-prev="fade"
            transition-next="fade"
            class="bg-green-1 text-red text-center"
          >
            <q-tab-panel name="carrito" class="">
              <div class="row">
                <q-space />
                <div class="text-h6">Carrito de compras</div>
                <q-space />
              </div>
              <q-separator />
              <q-list style="width: 100%" class="rounded-borders">
                <div
                  class="flex column"
                  v-for="pedido in paraPedir"
                  :key="pedido.id"
                >
                  <q-item>
                    <q-item-section avatar top>
                      <q-btn
                        flat
                        dense
                        round
                        icon="delete"
                        @click="
                          removeToCart({
                            id: pedido.id,
                            description: pedido.description,
                            price: pedido.price,
                            cantPedida: pedido.cantPedida,
                          })
                        "
                      />
                    </q-item-section>
                    <q-item-section
                      top
                      style="min-width: 400px; max-width: 600px"
                    >
                      <q-item-label lines="1">
                        <span class="text-weight-medium">
                          Cod. {{ pedido.id }} - {{ pedido.description }}
                        </span>
                        <span class="text-grey-8">
                          - Precio Unidad: ${{ pedido.price }}
                        </span>
                      </q-item-label>
                      <q-item-label caption lines="1">
                        Pedido Cant.: {{ pedido.cantPedida }} total precio: $
                        {{ pedido.cantPedida * pedido.price }}
                      </q-item-label>
                      <q-input
                        dense
                        v-model="pedido.observaciones"
                        filled
                        label="Observaciones"
                        type="text"
                      />
                    </q-item-section>

                    <q-item-section top side>
                      <div class="text-grey-8 q-gutter-xs">
                        <!-- desde aca -->
                        <div class="center" style="width: 100px">
                          <q-input
                            readonly
                            type="text"
                            dense
                            rounded
                            outlined
                            bottom-slots
                            v-model="pedido.cantPedida"
                            :rules="[
                              (val) =>
                                val >= 0 || 'Debe ingresar un valor mayor a 1',
                            ]"
                            input-class="text-center"
                          >
                            <template v-slot:prepend>
                              <q-icon
                                name="remove"
                                @click="
                                  (pedido.cantPedida = pedido.cantPedida - 1),
                                    (this.precioTotal =
                                      pedido.cantPedida < 0
                                        ? this.precioTotal
                                        : this.precioTotal - pedido.price),
                                    (pedido.cantPedida =
                                      pedido.cantPedida < 0
                                        ? 0
                                        : pedido.cantPedida)
                                "
                              />
                            </template>
                            <template v-slot:append>
                              <q-icon
                                name="add"
                                @click="
                                  (pedido.cantPedida = pedido.cantPedida + 1),
                                    (this.precioTotal =
                                      this.precioTotal + pedido.price)
                                "
                                class="cursor-pointer"
                              />
                            </template>
                          </q-input>
                        </div>
                        <!-- hasta aca -->
                      </div>
                    </q-item-section>
                  </q-item>
                  <!-- </div> -->

                  <q-separator />
                </div>
              </q-list>
              <div class="row">
                <q-btn
                  class="full-width"
                  color="teal"
                  push
                  @click="visible = !visible"
                >
                  <div class="row items-center no-wrap">
                    <q-icon left name="payment" />
                    <div class="text-center">
                      Total Pagar:
                      {{ precioTotal }}
                    </div>
                  </div>
                </q-btn>
                <q-slide-transition>
                  <div v-show="visible">
                    <q-form>
                      <div class="row full-width">
                        <div class="full-width">
                          <q-select
                            v-model="idPago"
                            :options="mediosPagos"
                            label="Medios de Pago"
                            option-value="id"
                            option-label="kind"
                            option-disable="inactive"
                            emit-value
                            map-options
                            lazy-rules
                            :rules="[
                              (val) =>
                                val !== null ||
                                `Please use maximum 3 characters - ${val}`,
                            ]"
                          >
                            <template v-slot:prepend>
                              <q-icon name="payment" />
                            </template>
                          </q-select>
                        </div>
                        <div class="full-width">
                          <q-input
                            square
                            clearable
                            v-model="direccion_envio"
                            type="string"
                            label="Direccion de envio"
                          >
                            <template v-slot:prepend>
                              <q-icon name="home" />
                            </template>
                          </q-input>
                        </div>
                        <div class="full-width">
                          <q-btn
                            unelevated
                            size="lg"
                            color="purple-4"
                            class="full-width text-white"
                            label="Guardar"
                            @click="addPedido"
                          />
                        </div>
                      </div>
                    </q-form>
                  </div>
                </q-slide-transition>
              </div>
            </q-tab-panel>
          </q-tab-panels>

          <!-- Pedidos -->
          <q-tab-panels
            v-model="tab"
            animated
            transition-prev="jump-up"
            transition-next="jump-down"
            class="bg-teal text-white text-center"
          >
            <q-tab-panel name="mispedidos">
              <div class="text-h6">Mis pedidos</div>

              <div class="q-pa-md">
                <q-table
                  title="Treats"
                  :rows="allPedidos"
                  :columns="columns"
                  row-key="id"
                  :filter="filter"
                  :loading="loading"
                >
                  <template v-slot:top>
                    <q-space />
                    <q-input
                      borderless
                      dense
                      debounce="300"
                      color="primary"
                      v-model="filter"
                    >
                      <template v-slot:append>
                        <q-icon name="search" />
                      </template>
                    </q-input>
                  </template>

                  <template v-slot:header="props">
                    <q-tr :props="props">
                      <q-th auto-width />
                      <q-th auto-width> Pagos </q-th>

                      <q-th
                        v-for="col in props.cols"
                        :key="col.name"
                        :props="props"
                      >
                        {{ col.label }}
                      </q-th>
                    </q-tr>
                  </template>
                  <template v-slot:body="props">
                    <q-tr :props="props">
                      <q-td auto-width>
                        <q-btn
                          size="sm"
                          color="accent"
                          round
                          dense
                          @click="props.expand = !props.expand"
                          :icon="props.expand ? 'visibility_off' : 'visibility'"
                        />
                      </q-td>
                      <q-td auto-width>
                        <q-btn
                          color="lima-1"
                          icon="img:/icons/paypal.png"
                          @click="paypal(props.row.total_pay, props.row.id)"
                          v-if="props.row.state_id == 1"
                        >
                        </q-btn>
                        <q-btn
                          color="lima-1"
                          icon="img:/icons/mpago.png"
                          @click="mpago(props.row.total_pay, props.row.id)"
                          v-if="props.row.state_id == 1"
                        >
                        </q-btn>
                      </q-td>
                      <!-- id -->
                      <q-td key="id" :props="props">
                        {{ props.row.id }}
                      </q-td>
                      <!-- Estado  -->
                      <q-td key="state_id" :props="props">
                        {{ estados[props.row.state_id - 1].estado }}
                      </q-td>
                      <!-- fecha  -->
                      <q-td key="application_date" :props="props">
                        {{ props.row.application_date }}
                      </q-td>
                      <!-- Hora  -->
                      <q-td key="request_time" :props="props">
                        {{ props.row.request_time }}
                      </q-td>
                      <!-- direccion envio  -->
                      <q-td key="shipping_address" :props="props">
                        {{ props.row.shipping_address }}
                      </q-td>
                      <!-- Total a pagar  -->
                      <q-td key="total_pay" :props="props">
                        {{ props.row.total_pay }}
                      </q-td>
                      <!-- Medio de pago -->
                      <q-td key="payment_methods_id" :props="props">
                        {{
                          (qq = mediosPagos.find(
                            (m) => m.id === props.row.payment_methods_id
                          )).kind
                        }}
                      </q-td>
                    </q-tr>
                    <q-tr v-show="props.expand" :props="props">
                      <q-td colspan="100%">
                        <div class="text-left">
                          <q-list style="width: 100%" class="rounded-borders">
                            <div
                              class="flex column"
                              v-for="producto in props.row.products"
                              :key="producto.description"
                            >
                              {{ producto.description }}:
                              {{
                                producto.orders_has_products.ordered_quantity
                              }}
                              *
                              {{ producto.orders_has_products.unit_price }}
                              =
                              {{ producto.orders_has_products.line_price }}
                            </div>
                          </q-list>
                        </div>
                      </q-td>
                    </q-tr>
                  </template>
                </q-table>
              </div>
            </q-tab-panel>
          </q-tab-panels>
        </div>
      </div>
    </div>
  </q-page>
</template>
<script>
import { api } from "boot/axios";
import { ref, onMounted } from "vue";
import { useQuasar, SessionStorage } from "quasar";
import ViewProduct from "src/components/product/viewProduct.vue";

const columns = [
  {
    name: "id",
    required: true,
    label: "Nro Pedido",
    align: "left",
    field: (row) => row.id,
    format: (val) => `${val}`,
    sortable: true,
  },
  {
    name: "state_id",
    align: "center",
    label: "Estado",
    field: "state_id",
    //sortable: true,
  },

  {
    name: "application_date",
    align: "center",
    label: "Fecha Pedido",
    field: "application_date",
    sortable: true,
  },
  {
    name: "request_time",
    align: "center",
    label: "Hora Pedido",
    field: "request_time",
    sortable: true,
  },
  {
    name: "shipping_address",
    align: "center",
    label: "Direccion de entrega",
    field: "shipping_address",
    sortable: true,
  },
  {
    name: "total_pay",
    align: "center",
    label: "Total a Pagar",
    field: "total_pay",
    sortable: true,
  },
  {
    name: "payment_methods_id",
    align: "center",
    label: "Medio de pago id",
    field: "payment_methods_id",
    sortable: true,
  },
];
let estados = [
  {
    id: 1,
    estado: "Pendiente",
    detalle: "cuando el usuario inicia su pedido.",
  },
  {
    id: 2,
    estado: "Confirmado",
    detalle: "cuando el usuario cierra su pedido.",
  },
  {
    id: 3,
    estado: "Preparación",
    detalle: "cuando el administrador comienza a preparar el pedido.",
  },
  {
    id: 4,
    estado: "Enviado",
    detalle: "cuando el administrador envía el pedido.",
  },
  {
    id: 5,
    estado: "Cancelado",
    detalle: "cuando el usuario cancela su pedido.",
  },
  {
    id: 6,
    estado: "Entregado",
    detalle: "cuando el administrador entrega el pedido.",
  },
];

export default {
  setup() {
    const step = ref(1);

    let data = ref([]);
    let user = ref([]);
    const $q = useQuasar();
    let allProducts = ref([]);
    let text = ref();
    let paraPedir = ref([]);
    let totalCarrito = ref(0);
    let precioTotal = ref(0);
    let direccion_envio = ref("");
    const idPago = ref(1);

    let token = SessionStorage.getItem("jwt");
    const mediosPagos = ref(null);
    async function cargarMediosPagos() {
      api
        .get("mediosPago", {
          headers: {
            accept: "application/json",
            Authorization: token,
          },
        })
        .then((response) => {
          mediosPagos.value = response.data.data;
        })
        .catch((error) => {
          $q.notify({
            color: "negative",
            position: "bottom",
            message: `code: ${error.response.status} - Mensaje ${error}`,
            icon: "report_problem",
          });
        });
    }

    function returnProducts() {
      paraPedir.value.splice(0, paraPedir.value.length);
      totalCarrito.value = 0;
      precioTotal.value = 0;

      api
        .get("productos", {
          headers: {
            accept: "application/json",
            Authorization: token,
          },
        })
        .then((response) => {
          data.value = response.data.data;
          allProducts.value = response.data.data;
          //    return JSON.stringify(response.data.data);
        })
        .catch((error) => {
          $q.notify({
            color: "negative",
            position: "bottom",
            message: `code: ${error.response.status} - Mensaje ${error}`,
            icon: "report_problem",
          });
        });
    }

    let allPedidos = ref([]);

    function returnPedidos() {
      api
        .get("pedidos", {
          headers: {
            accept: "application/json",
            Authorization: token,
          },
        })
        .then((response) => {
          allPedidos.value = response.data.data;
        })
        .catch((error) => {
          $q.notify({
            color: "negative",
            position: "bottom",
            message: `Mensaje es aca?3 ${error}`,
            icon: "report_problem",
          });
        });
    }

    onMounted(() => {
      returnProducts();
      cargarMediosPagos();
      returnPedidos();
    });

    const loading = ref(false);
    const filter = ref("");
    const rowCount = ref(10);
    // const rows = ref([allPedidos]);
    let tab = ref("pedidos");
    return {
      async mpago(precioPagar, idPedido) {
        location.href =
          `${process.env.API}/mecardopago/mpago` +
          "?totaltopay_order=" +
          precioPagar +
          "&id_order=" +
          idPedido +
          "&token= " +
          token;
        // emite error de cors
        /*   api
          .get(
            "/pedidos/mpago?totaltopay_order=" +
              precioPagar +
              "&id_order=" +
              idPedido,
            {
              headers: {
                accept: "application/json",
                Authorization: token,
              },
            }
          )
          .then((response) => {
            console.log(`respuesta ${JSON.stringify(response.data.data)}`);
          })
          .catch((error) => {
            $q.notify({
              color: "negative",
              position: "bottom",
              message: ` Error desde respuesta de url Mercado pago ${error}`,
              icon: "report_problem",
            });
          });
       */
      },

      async paypal(precioPagar, idPedido) {
        const totalPagar = {
          precioPagar: precioPagar,
          id: idPedido,
        };
        await api
          .post("pedidos/create-payment", totalPagar, {
            headers: {
              accept: "application/json",
              Authorization: token,
            },
          })
          .then((response) => {
            console.log(`response paypal ${JSON.stringify(response)}`);
            location.href = response.data.links[1].href;
            return true;
          })
          .catch((error) => {
            console.log(`response paypal ${JSON.stringify(error)}`);

            $q.notify({
              color: "negative",
              position: "bottom",
              message: "No se pudo realizar el pago",
              icon: "sentiment_very_dissatisfied",
            });
          });
      },
      getUsers() {
        api
          .get("view", {
            headers: {
              accept: "application/json",
              Authorization: token,
            },
          })
          .then((response) => {
            console.log(`que llega en la primer carga${response.data}`);
            user.value = response.data.payload.dataUser;
            direccion_envio.value =
              response.data.payload.dataUser.shipping_address;
            return JSON.stringify(response.data.data);
          })
          .catch((error) => {
            $q.notify({
              color: "negative",
              position: "bottom",
              message: ` Mensaje es aca?2 ${error}`,
              icon: "report_problem",
            });
          });
      },

      async addPedido() {
        const pedidoNew = {
          direccion_envio: direccion_envio.value,
          medio_pago: idPago.value,
        };

        await api
          .post("pedidos", pedidoNew, {
            headers: {
              accept: "application/json",
              Authorization: token,
            },
          })
          .then((response) => {
            paraPedir.value.forEach((producto) => {
              let addProduct = {
                cant_pedido: producto.cantPedida,
                observaciones: producto.observaciones,
              };

              api
                .post(
                  `pedidos/${response.data.id}/productos/${producto.id}`,
                  addProduct,
                  {
                    headers: {
                      accept: "application/json",
                      Authorization: token,
                    },
                  }
                )
                .then((response) => {})
                .catch((error) => {
                  $q.notify({
                    color: "negative",
                    position: "bottom",
                    message: "No se pudo guardar el nuevo usuario",
                    icon: "sentiment_very_dissatisfied",
                  });
                });
            }),
              $q.notify({
                color: "positive",
                position: "bottom",
                message: `Se creo el usuario ${direccion_envio.value}`,
                icon: "mood",
              });

            return JSON.stringify(response.data);
          })
          .catch((error) => {
            $q.notify({
              color: "negative",
              position: "bottom",
              message: "No se pudo guardar el nuevo usuario",
              icon: "sentiment_very_dissatisfied",
            });
          });

        // Recarga los pedidos
        setTimeout(() => {
          returnPedidos();
        }, 2000);

        returnProducts();
        tab.value = "mispedidos";
      },

      filtro() {
        allProducts.value = data.value.filter((row) =>
          row.description.includes(text.value)
        );
      },

      allProducts,
      paraPedir,
      text,
      data,
      step,
      tab,
      visible: ref(false),
      totalCarrito,
      precioTotal,
      mediosPagos,
      idPago,
      user,
      direccion_envio,

      // tabla
      columns,
      loading,
      filter,
      rowCount,
      allPedidos,
      estados,
      verProduct: ref(false),
    };
  },
  methods: {
    getToCart(datos) {
      let pos = this.allProducts
        .map(function (e) {
          return e.id;
        })
        .indexOf(datos["id"]);
      this.allProducts.splice(pos, 1);
      this.paraPedir.push(datos);
      this.totalCarrito = this.paraPedir.length;
      this.precioTotal =
        this.precioTotal + datos["cantPedida"] * datos["price"];
    },
    removeToCart(datos) {
      let pos = this.paraPedir
        .map(function (e) {
          return e.id;
        })
        .indexOf(datos["id"]);
      this.precioTotal =
        this.precioTotal - datos["cantPedida"] * datos["price"];
      this.paraPedir.splice(pos, 1);
      this.allProducts.push(datos);
      this.totalCarrito = this.paraPedir.length;
      if (this.totalCarrito === 0) {
        this.tab = "pedidos";
      }
    },
  },
  components: { ViewProduct },
};
</script>
<style lang="sass" scoped>
.my-card
  width: 100%
</style>
